<?php

/**
 * inf_prescripcion actions.
 *
 * @package    cobro_coactivo
 * @subpackage inf_prescripcion
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_prescripcionActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_RESOLUCION_TIT',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUALIZA_TITULO',
        'CBR_PAR',
        'CBR_CONCEPTO_RESOL',
        'CBR_REPARTO',
        'CBR_ABOGADO',
        'INTERCEROS_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_REMISION_TITULO,LEFT' =>
        array(
            'cod_titulo' => 'CBR_RESOLUCION_TIT'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_RESOLUCION_TIT'
        ),
        'CBR_ACTUALIZA_TITULO,LEFT' =>
        array(
            'cod_titulo' => 'CBR_RESOLUCION_TIT'
        ),
        'CBR_PAR,LEFT' =>
        array(
            'id_par' => 'CBR_REMISION_TITULO'
        ),
        'CBR_CONCEPTO_RESOL,LEFT' =>
        array(
            'id_concepto_resol' => 'CBR_RESOLUCION_TIT'
        ),
        'CBR_REPARTO,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ABOGADO,LEFT' =>
        array(
            'id_abogado' => 'CBR_REPARTO'
        ),
        'INTERCEROS_V,LEFT' =>
        array(
            'id_mae_ter' => 'CBR_ABOGADO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_RESOLUCION_TIT' =>
        array(
            'id_resolucion_tit' => 'id_resolucion_tit',
            'id_concepto_resol' => 'id_concepto_resol',
            'no_resolucion' => 'no_resolucion',
            'fecha_exigibilidad' => 'fecha_exigibilidad',
            'fecha_fin_exigibilidad' => 'fecha_fin_exigibilidad'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'numero_correpondencia' => 'numero_correpondencia',
            'fecha_remision' => 'fecha_remision',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral'
        ),
        'CBR_ACTUALIZA_TITULO' =>
        array(
            'nitocc' => 'nitocc',
            'nombre_razon' => 'nombre_razon'
        ),
        'CBR_CONCEPTO_RESOL' =>
        array(
            'descripcion' => 'concepto'
        ),
        'INTERCEROS_V' =>
        array(
            'razon_soc' => 'abogado',
            'num_doc'=>'num_doc'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'cod_titulo', 'nitocc', 'no_resolucion', 'numero_remision'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_RESOLUCION_TIT' =>
        array(
            'id_resolucion_tit,a' => array('!=' => array(-1)),
            'id_resolucion_tit,b' => array('=' => array('id_resolucion_tit')),
            'fecha_fin_exigibilidad' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'cod_titulo' => array('=' => array('cod_titulo')),
            'no_resolucion' => array('=' => array('no_resolucion')),
            'id_concepto_resol' => array('=' => array('id_concepto_resol')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_ACTUALIZA_TITULO' =>
        array(
            'nitocc' => array('=' => array('num_doc'))
        ),
        'CBR_REPARTO' =>
        array(
            'id_abogado' => array('=' => array('id_abogado'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    public function executeList2(sfWebRequest $request) {
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejar Errores
         */
        try {

            /*
             * Variables para el registro de log
             */

            //1 - indica operacion de consulta
            $id_ope_bd = 1;

            //obtener id maestro tabla
            $id_mae_bd = CN_TABLE::consultarIdTablaBD('CBR_RESOLUCION_TIT');


            //CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, $observacion);

            /*
             * Filtro para que levante por CO_ESTUDIOS_PREVIOS y por FASE
             */

            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            /*
             * Obtiene las vigencias/periodo que se encuentre en la tabla de saldos
             */
            $sql = <<<EOD
select tab2.cod_titulo as cod_titulo,tab0.NO_RESOLUCION,tab0.FECHA_EXIGIBILIDAD,
    tab0.FECHA_FIN_EXIGIBILIDAD,tab3.NITOCC,tab3.NOMBRE_RAZON,tab5.DESCRIPCION as concepto,
tab8.RAZON_SOC as abogado

from CBR_RESOLUCION_TIT tab0
left join CBR_REMISION_TITULO tab1 ON tab1.cod_titulo = tab0.cod_titulo
left join CBR_TITULO_MINERO_V tab2 ON tab2.cod_titulo = tab0.cod_titulo
left join CBR_ACTUALIZA_TITULO tab3 ON tab3.cod_titulo = tab0.cod_titulo
left join CBR_PAR tab4 ON tab4.id_par = tab1.id_par
left join CBR_CONCEPTO_RESOL tab5 ON tab5.ID_CONCEPTO_RESOL = tab0.ID_CONCEPTO_RESOL
left join cbr_reparto tab6 ON tab6.id_remision_titulo = tab1.id_remision_titulo
left join CBR_ABOGADO tab7  ON tab7.id_abogado = tab6.id_abogado
left join interceros_v tab8 ON tab8.id_mae_ter = tab7.id_mae_ter



where tab0.FECHA_FIN_EXIGIBILIDAD BETWEEN to_date('$fecha_ini','YYYY-MM-DD') AND  to_date('$fecha_fin','YYYY-MM-DD')
order by tab0.FECHA_EXIGIBILIDAD
                    
EOD;
            $records = CN_TABLE::executeSQL($sql);

            //Ejecuta sql
            $this->totalRows = count($records);
            $this->list_data = $records;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
